apiVersion: apps/v1
kind: Deployment
metadata:
  name: postgresql
  labels:
    app: postgresql
spec:
  replicas: 1
  selector:
    matchLabels:
      app: postgresql
  template:
    metadata:
      labels:
        app: postgresql
    spec:
      affinity:
        podAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchLabels:
                app: postgresql
            topologyKey: kubernetes.io/hostname

      containers:
      # - image: busybox
      #   name: prep
      #   volumeMounts:
      #     - name: postgresql-v
      #       mountPath: /mnt/pg-data
      #   command: ["sleep", "99999"]
      #   resources: {}

      - name: postgresql
        image: postgres:16.0-bookworm
        ports:
        - name: postgresql
          containerPort: 5432
        env:
        - name: "PGDATA"
          value: "/var/lib/postgresql/data/pgdata"
        - name: "POSTGRES_USER"
          value: "postgres"
        - name: "POSTGRES_PASSWORD"
          valueFrom:
            secretKeyRef:
              key: postgres-password
              name: postgresql-secrets
        volumeMounts:
        - mountPath: /var/lib/postgresql/data/
          name: postgresql-v
        resources: {}

      volumes:
      - name: postgresql-v
        persistentVolumeClaim:
          claimName: postgresql-pvc

---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: postgresql-pvc
spec:
  storageClassName: longhorn
  accessModes:
  - ReadWriteOnce
  resources:
    requests:
      storage: 500Mi

---
apiVersion: v1
kind: Service
metadata:
  name: postgresql
  labels:
    app: postgresql
spec:
  type: ClusterIP
  sessionAffinity: None
  ports:
  - name: tcp
    port: 5432
    protocol: TCP
    targetPort: postgresql
  selector:
    app: postgresql
